/************************************************************/
/*                                                          */
/*       *** HAPPy Pascal Compiler ***                      */
/*        ̃RpC                                */
/*      void expression(Set fsys) ;                         */
/*                                                          */
/*                 Copyright (c) H.Asano 1992,1994.         */
/*                                                          */
/************************************************************/

#define EXTERN extern
#include "pascomp.h"
#include "pcpcd.h"

extern void gen0(enum pcdmnc) ;
extern void genp(enum pcdmnc,int) ;
extern void gen0t(enum pcdmnc,stp*) ;
extern void gen1t(enum pcdmnc,stp*,int)     ;
extern void gen2t(enum pcdmnc,stp*,int,int) ;
extern void gencompare(enum pcdmnc,char,int) ;
extern void genldc(char,long) ;
extern void genixa(long,int)  ;
extern void genchk(stp*,int,long,long) ;
extern void convertint(stp*)  ;
extern void load(void) ;
extern void loadaddress(void) ;
extern ctp  *searchsection(ctp*) ;
extern ctp  *searchid(Set) ;
extern void insymbol(void) ;
extern void pcerr(int,char*);
extern char *inttoch(long)  ;
extern void skip(Set) ;
extern boolean string(stp*) ;
extern boolean compatible(stp*,stp*) ;
extern void getbounds(stp*,long*,long*) ;
extern int align(stp*,int) ;
extern void conststrings(stp**, union valu*) ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*) ;
extern void call(Set,ctp*) ;
extern void *Malloc(int)   ;
static void array(Set) ;
static void recordmember(void) ;
static void ptr(void) ;
static void factident(Set) ;
static void factconst(Set) ;
static void factlparent(Set) ;
static void factnot(Set)   ;
static void factset(Set)   ;
static void factset2(Set,stp*,long*,boolean*,boolean*) ;
static void factnil(void)  ;
static void simpleexpression(Set) ;
static void plusminusope(attr,enum operator) ;
static void orope(attr)    ;
static void mulope(attr)   ;
static void rdivope(attr)  ;
static void inope(attr)    ;
static void relope(attr,enum operator)  ;
static void cnvfloat(attr*)   ;

/*******************************************/
/* expression() : ̃RpCC */
/*******************************************/
void expression(Set fsys)
{
  attr lattr ;
  enum operator lop ;
  Set ws ;

     ws = fsys ;
     addset(ws,relop) ;
     simpleexpression(ws) ;

     if(sy == relop) {                  /* ֌WZq̎             */
      if(gattr.typtr)
       if(gattr.typtr->form <= power)   /*  XJ͈͌^W^̎  */
        load() ;                        /*   load                 */
       else loadaddress() ;             /*  ȊO͊ԐڎQ        */
      lattr = gattr ;                   /* ̎̑ޔ         */
      lop   = op    ;                   /* ̉Zqޔ           */

      if(lop == inop)                   /* in ̎ integerłȂ  */
       if(gattr.typtr && (gattr.typtr->form == scalar) &&
          (gattr.typtr != realptr))    /* in̑O̎^̎     */
        convertint(gattr.typtr) ;       /* KvȂordߐ        */

      insymbol()    ;
      simpleexpression(fsys) ;          /* ֌WZq̎̒P̏*/
      if(gattr.typtr)
       if(gattr.typtr->form <= power)   /* XJ͈͌^W^̎   */
        load() ;                        /*  load                  */
       else loadaddress() ;             /* ȊO͊ԐڎQ         */

      if((lattr.typtr) && (gattr.typtr))
       if(lop == inop) inope(lattr) ;   /* in Zq              */
       else {
        if(lattr.typtr != gattr.typtr)
         cnvfloat(&lattr) ;             /* realւ̕ϊ           */

        if(compatible(lattr.typtr,gattr.typtr))  /* ̌^    */
         relope(lattr,lop) ;            /* ֌WZq̏           */
        else pcerr(143,"") ;            /* Zq̗[̌^sv   */
       }

      gattr.typtr = boolptr ;
      gattr.kind  = expr    ;           /* ȍ~_^̎Ƃ   */
     }

}

/**************************************/
/*      inope() : in Zq       */
/**************************************/
static void inope(attr fattr)
{
     if(gattr.typtr->form == power)           /* ̌^W^          */
      if(compatible(fattr.typtr,gattr.typtr->sf.pw.elset))
                                              /* ̌^Ɠ      */
       gen0(iINN) ;                           /* inn߂𐶐           */
      else {
       pcerr(143,"") ;                        /* Zq̗[̌^sv*/
       gattr.typtr = nil ;
      }
     else {
      pcerr(130,"") ;                         /* ͏W^łȂ        */
      gattr.typtr = nil  ;
     }
}

/*****************************************/
/*  relope() : in ȊO̊֌WZq   */
/*              =  <  >  <>  <=  >=      */
/*****************************************/
static void relope(attr fattr,enum operator fop)
{
  int lsize ;                           /* r傫             */
  char typind ;                         /* r߂̌^               */
  enum pcdmnc pcd ;                     /* P-code                 */

     lsize = fattr.typtr->size ;        /* ̌^̑傫             */

     switch(fattr.typtr->form) {        /* ^ŐU蕪             */
      case scalar :                     /* XJ[                   */
        if(fattr.typtr == realptr)      typind = 'r' ;  /* real       */
        else if(fattr.typtr == boolptr) typind = 'b' ;  /* boolean    */
        else if(fattr.typtr == charptr) typind = 'c' ;  /* char       */
        else                            typind = 'i' ;  /* integer/񋓌^*/
        break ;
      case pointer :                    /* |C^^                 */
        if((fop != eqop) && (fop != neop)) /* =  <> ȊO              */
         pcerr(131,"") ;                /* ǂ̔肵ʖ*/
        typind = 'a'   ;
        break ;
      case power   :                    /* W^                     */
        if((fop == ltop) || (fop == gtop)) /* <  >  ̎              */
         pcerr(132,"") ;                /*  S܂̔͑ʖ      */
        typind = 's'   ;
        break ;
      case arrays :                     /* z^                     */
        if(! string(fattr.typtr))       /*  łȂ            */
         pcerr(134,"") ;                /*  ZΏۂ̌^Ɍ        */
         typind = 'm'  ;
         break ;
      case records :                    /* R[h^                 */
        pcerr(134,"")  ;                /*  R[h^͑ʖ          */
        typind = 'm'   ;
        break          ;
      case files :                      /* t@C^                 */
        pcerr(133,"")  ;                /*   t@C̔r͑ʖ     */
        typind = 'f'   ;
     }

     switch(fop) {                      /* ZqŐ߂     */
      case ltop : pcd = iLES ; break ;  /* <  les                 */
      case leop : pcd = iLEQ ; break ;  /* <= leq                 */
      case gtop : pcd = iGRT ; break ;  /* >  grt                 */
      case geop : pcd = iGEQ ; break ;  /* >= geq                 */
      case neop : pcd = iNEQ ; break ;  /* <> neq                 */
      case eqop : pcd = iEQU ;          /* =  neq                 */
     }
     gencompare(pcd,typind,lsize)    ;  /* ߐ                   */
}

/**************************************/
/* cnvfloat() : realւ̕ϊ      */
/**************************************/
static void cnvfloat(attr *fattr)
{

      if((*fattr).typtr == intptr) {    /* O̎integer            */
       gen0(iFLO) ;                     /*  O̎ realɕϊ       */
       (*fattr).typtr = realptr ;
      } ;
      if(gattr.typtr == intptr) {       /* ̎integer              */
       gen0(iFLT) ;                     /*  ̎realɕϊ        */
       gattr.typtr = realptr ;
      }
}

/***************************************/
/* selector() : ϐ̑I   */
/*      []  :  zϐ           */
/*      ^      :  |C^ϐ       */
/*      .      : R[hϐ        */
/***************************************/
void selector(Set fsys, ctp *fcp)
{
  Set ws ;

     gattr.typtr = fcp->idtype ;        /* ^ݒ                   */
     gattr.kind  = varbl       ;        /* ނ ϐ                */
     switch(fcp->klass) {               /* ϐ̌^ŐU蕪       */
      case vars :                       /*[ϐ]                      */
        if(fcp->n.v.vkind == actual) {  /*  ϐ                    */
         gattr.access = drct ;
         gattr.vlevel = fcp->n.v.vlev ;
         gattr.dplmt  = fcp->n.v.vaddr;
        }
        else {                          /*  formal (ϐ)         */
         if(gattr.typtr->form != files) /* ٌ̧^loda𐶐Ȃ   */
          gen2t(iLOD,nilptr,level-fcp->n.v.vlev,fcp->n.v.vaddr) ;
         gattr.access = indrct ;
         gattr.idplmt = 0      ;
         gattr.vlevel = fcp->n.v.vlev ; /* t@Cϐ̎   */
         gattr.dplmt  = fcp->n.v.vaddr; /* ߂ɑޔĂ         */
        }                               /* {͈͂̂ᔽł */
        break ;

      case field :                      /* R[h̃tB[h       */
                                        /* withzȂ͂   */
        if(display[disx].occur == crec){/* ŒtB[h̎         */
         gattr.access = drct ;
         gattr.vlevel = display[disx].clev ;
         gattr.dplmt  = display[disx].cdspl+ fcp->n.fldaddr ;
        }
        else {                          /* vrec(σtB[h̎)   */
         if(level == 1)                 /* ϐ                   */
          gen1t(iLDO,nilptr,display[disx].vdspl) ;        /* ldo  */
         else  gen2t(iLOD,nilptr,0,display[disx].vdspl) ; /* lod  */
         gattr.access = indrct ;
         gattr.idplmt = fcp->n.fldaddr ;
        }
       break;

      case func  :                      /* ֐                       */
        gattr.access = drct ;
        gattr.vlevel = fcp->n.pf.sd.d.pflev + 1 ;
        gattr.dplmt  = 0    ;

     }

     ws = selectsys ;
     orset(&ws,&fsys) ;
     if(! inset(ws,sy)) {
      pcerr(59,"") ;                    /* ϐɌ肪           */
      skip(ws)     ;                    /* fsys+selectsys܂œǂݔ΂*/
     }

     while(inset(selectsys,sy)) {       /* [  .  ^  ̊ԏ      */
      if(sy == lbrack)                  /*  [ ̎                    */
       array(fsys) ;                    /*   z̏               */
      else if(sy == period)             /*  . ̎                    */
       recordmember() ;                 /*   R[h̊evf̏   */
      else                              /*  ^ ̎                    */
       ptr() ;                          /*    |C^̏          */

      if(! inset(ws,sy)) {
       pcerr(6,"") ;                    /* sȋLꂽ         */
       skip(ws) ;
      }
     }
}

/*****************************************/
/* recordmember() : R[h̗vf̏ */
/*****************************************/
static void recordmember(void)
{
  ctp *lcp ;

     if(gattr.typtr)
      if(gattr.typtr->form != records) {
       pcerr(140,"") ;                  /* ϐ̌^R[h^łȂ */
       gattr.typtr = nil ;              /* ̃G[h~̂nilɂ*/
      }

     insymbol() ;                       /* symbol                 */
     if(sy == ident) {                  /*  O                      */
      if(gattr.typtr) {                 /*  R[h̗vf疼OT*/
       lcp = searchsection(gattr.typtr->sf.re.fstfld) ;
       if(!lcp) {                       /*  OȂ              */
        pcerr(152,id) ;                 /*  R[h̗ł͂Ȃ      */
        gattr.typtr = nil ;             /* ̃G[h~̂nilɂ*/
       }
       else {                           /* OR[h̗̎     */
        gattr.typtr = lcp->idtype ;     /*   Ǒ^                 */
        if(gattr.access==drct)          /* ڎQƂ̎               */
           gattr.dplmt += lcp->n.fldaddr ;
        else                            /* ԐڎQƂ̎(indrct)       */
           gattr.idplmt += lcp->n.fldaddr ;
       }
      }                                 /* end (typtr != nil)         */
      insymbol() ;                      /* O̎ǂݍ         */
     }
     else pcerr(2,"") ;                 /* OȂ                 */
}

/*****************************************/
/*      array() : z̏             */
/*****************************************/
static void array(Set fsys)
{
  attr lattr ;                          /* 1Ȏ                */
  long lmin,lmax ;
  int lsize ;
  int incsize ;
  Set  ws    ;

     do {                               /* ẑ߂̌JԂ */
      lattr = gattr ;
      if(lattr.typtr)
       if(lattr.typtr->form != arrays) {
        pcerr(138,"") ;                 /* ϐ̌^͔złȂ       */
        lattr.typtr = nil ;
        gattr.typtr = nil ;             /* loadaddressȂ      */
       }
      loadaddress() ;
      insymbol() ;
      mkset(&ws, comma,rbrack, -1) ;
      orset(&ws, &fsys) ;
      expression(ws)    ;               /* Y̎̏           */

      if(gattr.typtr) {
       if(gattr.typtr->form != scalar)
        pcerr(113,"") ;                 /* Y̌^̓XJ͈͌^ */
       lsize = lattr.typtr->sf.ar.aeltype->size ;
       lsize = align(gattr.typtr,lsize) ; /* E킹               */
      }
      if(lattr.typtr) {
       if(compatible(lattr.typtr->sf.ar.inxtype,
                     gattr.typtr)) {    /* Y̌^Ɠ         */
        if(lattr.typtr->sf.ar.inxtype) {
         getbounds(lattr.typtr->sf.ar.inxtype,&lmin,&lmax);
         if(gattr.typtr)
          if(gattr.kind == cst) {       /* Y萔̎           */
           if((lmin<=gattr.cval.ival) && (gattr.cval.ival<=lmax)) {
            incsize = (int)(gattr.cval.ival-lmin)*lsize ; /*    */
            if(incsize) gen1t(iINC,nilptr,incsize);
           }
           else pcerr(148,"") ;        /* Y̒萔͈͓ɂȂ  */
          }
          else {                        /* Y̎             */
           load() ;                     /* Yload             */
           convertint(gattr.typtr) ;    /* KvȂordߐ        */
           if(debug) genchk(intptr,1,lmin,lmax) ; /* chkߐ      */
           genixa(lmin,lsize) ;               /* lxa߂̐        */
          }
        }
       }
       else pcerr(139,"") ;            /* Y̌^錾ƈvȂ*/

       gattr.typtr  = lattr.typtr->sf.ar.aeltype ; /* vf̌^        */
       gattr.kind   = varbl ;
       gattr.access = indrct ;
       gattr.idplmt = 0 ;
      }

     } while(sy == comma) ;

     if(sy == rbrack) insymbol() ;
     else pcerr(12,"") ;                /* ] Ȃ                   */
}

/*******************************************/
/* ptr() : |C^Q,obt@ϐ̏ */
/*******************************************/
static void ptr(void)
{
     if(gattr.typtr)
      if(gattr.typtr->form == pointer) { /* |C^^̎            */
       load() ;
       gattr.typtr = gattr.typtr->sf.pt.eltype ; /* ŵ̌^  */
       if(debug)                        /* fobORpC̎     */
        gen0(iCKA) ;                    /* CKA                    */
       gattr.kind   = varbl ;
       gattr.access = indrct ;          /* ԐڎQ                   */
       gattr.idplmt = 0      ;
      }
      else if(gattr.typtr->form == files){/* t@C^̎           */
       if(gattr.access == indrct)       /* t@Cϐϐ̎ */
        gen2t(iLOD,nilptr,level-gattr.vlevel,gattr.dplmt) ;
       gattr.typtr = gattr.typtr->sf.fi.filtype ; /* t@C̊̌^ */
      }
      else pcerr(141,"") ;              /* t@C^wW^łȂ   */

      insymbol() ;
}

/**************************************/
/* factor() : ̈q(factor)̏  */
/**************************************/
static void factor(Set fsys)
{
  Set ws ;

     if(! inset(facbegsys,sy)) {
      pcerr(58,"") ;                    /* Ɍ肪             */
      ws = fsys ;
      orset(&ws, &facbegsys) ;
      skip(ws) ;                        /* fsys+factbegsys܂œǂݔ΂*/
      gattr.typtr = nil ;
     }

     while(inset(facbegsys,sy)) {
      switch(sy) {
       case ident       :               /* O̎                   */
              factident(fsys) ;
              break ;
       case intconst    :               /* 萔                   */
       case realconst   :               /* 萔                   */
       case stringconst :               /*                      */
              factconst(fsys) ;
              break ;
       case lparent     :               /* (                          */
              factlparent(fsys) ;
              break ;
       case notsy       :               /* not                        */
              factnot(fsys) ;
              break ;
       case lbrack      :               /* [    W̎n܂L      */
              factset(fsys) ;
              break ;
       case nilsy       :               /* nil                        */
              factnil() ;
              break ;
      }
      if(! inset(fsys,sy)) {
       pcerr(6,"") ;                    /* sȋLꂽ         */
       skip(ws)    ;                    /* fsys+factbegsys܂œǂݔ΂*/
      }
     }
}

/**************************************/
/*     factident() : Oq̏   */
/**************************************/
static void factident(Set fsys)
{
  ctp *lcp ;
  Set ws ;

     mkset(&ws, konst,vars,field,func,-1) ; /* O萔ϐtB[h */
     lcp = searchid(ws) ;                   /* ֐̒T             */
     insymbol() ;

     if(lcp->klass == func) {
      call(fsys,lcp) ;                  /* ֐̎֐Ăяo      */
      gattr.kind = expr ;
      if(gattr.typtr)
       if(gattr.typtr->form == subrange) /* ͈͌^̎                */
        gattr.typtr = gattr.typtr->sf.su.rangetype ; /* ̌^        */
    }
    else if(lcp->klass == konst) {      /* 萔̎                   */
     gattr.typtr = lcp->idtype ;
     gattr.kind  = cst ;
     gattr.cval  = lcp->n.values ;      /*  l                */
    }
    else {                              /* ϐR[htB[h̎*/
     selector(fsys,lcp) ;               /* I                   */
     if(gattr.typtr)
      if(gattr.typtr->form == subrange) /* ͈͌^̎                 */
       gattr.typtr = gattr.typtr->sf.su.rangetype ; /* ̌^         */
    }
}

/**************************************/
/*     factconst() : 萔q̏   */
/**************************************/
static void factconst(Set fsys)
{
  stp *lsp,*lsp1 ;

     gattr.kind = cst ;
     switch(sy) {
      case intconst :                   /* 萔                   */
        gattr.typtr = intptr ;
        gattr.cval  = val    ;          /* lݒ                   */
        break ;

      case realconst :                  /* 萔                   */
        gattr.typtr = realptr ;
        gattr.cval   = val    ;
        break ;

      case stringconst :                /*                      */
        conststrings(&(gattr.typtr),&(gattr.cval));/*萔̏ */
     }
     insymbol() ;
}

/**************************************/
/*   factlparent() : (`)̏       */
/**************************************/
static void factlparent(Set fsys)
{
  Set ws ;

     insymbol() ;
     ws = fsys  ;
     addset(ws,rparent) ;
     expression(ws) ;                   /* )oĂ܂Ŏ̏    */
     if(sy == rparent) insymbol() ;
     else pcerr(4,"")             ;     /* ) Ȃ                   */
}

/**************************************/
/*     factnot() : not ̏         */
/**************************************/
static void factnot(Set fsys)
{
     insymbol()   ;
     factor(fsys) ;                     /* not̎̈q̉        */
     load()       ;                     /* load߂̏o             */
     if(gattr.typtr != boolptr) {
      pcerr(135,"not") ;                /*  _^łȂƂȂ    */
      gattr.typtr = nil  ;              /*  ̃G[Ȃnil*/
     }
     gen0(iNOT)   ;                     /* not߂̏o              */
}

/**************************************/
/*     factset() : W̏         */
/**************************************/
static void factset(Set fsys)
{
  stp *lsp ;
  csp *lvp ;
  long    csetpart;                     /* W̒萔vfp[g       */
  boolean varpart ;                     /* ϐvf鎞 true      */
  boolean cstpart ;                     /* 萔vf鎞 true      */
  boolean test   ;
  Set ws  ;

     insymbol() ;
     csetpart= 0         ;              /* ŒvfW̃NA       */
     varpart = false     ;
     cstpart = false     ;
     lsp = (stp*)Malloc(sizeof(stp)) ;  /* W̌^쐬             */
     lsp->form          = power  ;
     lsp->size         = setsize ;
     lsp->assignflag   = true    ;
     lsp->sf.pw.packed = both    ;
     lsp->sf.pw.elset  = nil     ;
     lsp->sf.pw.elmin  = setlow  ;
     lsp->sf.pw.elmax  = sethigh ;

     if(sy == rbrack) {                 /* W̎                 */
      gattr.typtr = lsp ;
      gattr.kind  = cst ;
      insymbol() ;
     }

     else {                             /* vf鎞               */
      do {
       mkset(&ws,comma,rbrack,period2,-1);
       orset(&ws,&fsys) ;
       expression(ws)   ;               /* vf                       */
       if(gattr.typtr)
        if((gattr.typtr->form != scalar)/* vf^`FbN     */
        || (gattr.typtr == realptr)) {
         pcerr(136,"") ;                /*  vfLq͏^̂Ɓ@  */
         gattr.typtr = nil ;
        }
        else {
         if(!lsp->sf.pw.elset)          /* W̌^Ȃ           */
          lsp->sf.pw.elset = gattr.typtr ;/* vf̌^W̌^Ƃ */
         if(compatible(lsp->sf.pw.elset,gattr.typtr)){   /* vf̌^  */
          if(sy == period2)
           factset2(fsys,lsp,&csetpart,&cstpart,&varpart);/* ..̏ */
          else {                        /* ʏ̏Wvf̏       */
           if(gattr.kind == cst)        /* vf萔                 */
            if((gattr.cval.ival < (long)lsp->sf.pw.elmin) || /* W*/
               (gattr.cval.ival > (long)lsp->sf.pw.elmax))   /* ͈  */
             pcerr(607,inttoch((long)lsp->sf.pw.elmax)) ;/* ͈͓ɂȂ*/
            else {
             csetpart |=(1L << gattr.cval.ival);/* W̒萔vf*/
             cstpart = true ;
            }
           else {                       /* vfϐ̎             */
            load() ;                    /* vflload               */
            convertint(gattr.typtr) ;   /* KvȂordߐ        */
            if(debug)
             genchk(intptr,111,         /* HAPPy̏W͈͂ɓ邩*/
             (long)lsp->sf.pw.elmin,(long)lsp->sf.pw.elmax) ;
                                        /*  Wvf͈̔̓`FbN    */
            gen0(iSGS) ;                /* sgs(vf1̏W쐬) */
            if(varpart) gen0(iUNI)  ;   /* uni(ϐ̏Wɉ)*/
            else varpart = true     ;   /* ߂ĕϐꂽ true*/
           }
          }
         }
         else pcerr(137,"") ;           /* W̗vf̌^sv     */
        }

       if(test=(sy==comma)) insymbol(); /* , Ȃ玟̗vfǂ       */
      } while(test) ;                   /* , ȂΎ̗vf̏     */

      if(sy == rbrack) insymbol() ;     /* ] ȂΎsymbolǂ   */
      else pcerr(12,"") ;               /* ] Ȃ                   */

      gattr.typtr = lsp ;               /* W̌^           */
     }

     lvp = (csp*)Malloc(sizeof(csp)) ;  /* W萔̃GAm       */
     lvp->cclass = pset ;
     lvp->c.pval = csetpart ;
     gattr.cval.valp = lvp  ;

     if(varpart && cstpart) {           /* ϐvfƒ萔vf */
       genldc('s',(long)nil) ;          /* ldcs                   */
       gen0(iUNI) ;                     /* uni                    */
       gattr.kind = expr ;
      }
}

/****************************************/
/*  loadelement() :  W ͈͗vfload*/
/****************************************/
static void loadelement(stp *fsp,boolean *varpart,int kind)
{
  int pope ;                            /* mms߂ p Iyh
                                            0    `FbNȂ
                                            1    `FbN
                                            2    `FbNȂ
                                            3    `FbN */
    /* debugIvVw莞 chk߈ȊOŃ`FbN̂
       mms߂̂݁BꂪƂĂȂǁAbIɂ̂悤ɂ*/

     pope = kind + (int)(debug) ;
     load() ;                           /* vfload               */
     convertint(gattr.typtr)    ;       /* KvȂordߐ        */
     genp(iMMS,pope)            ;       /* mmsߐ                */
     if(*varpart) gen0(iUNI)    ;       /* uni(ϐ̏Wɉ)*/
     else *varpart = true       ;
}

/****************************************/
/*  factset2() :  W ͈͗vf̏ */
/*                 ..       */
/****************************************/
static void factset2(Set fsys,stp *fsp,
              long *csetpart,boolean *cstpart,boolean *varpart)
{
  attr lattr,lattr2 ;
  short m    ;
  Set ws     ;

     lattr = gattr ;
     if(gattr.kind != cst) {            /* 萔ȊO              */
      load() ;                          /* vfload               */
      convertint(gattr.typtr) ;         /* KvȂordߐ        */
      insymbol() ;                      /* ̗vfǂ             */
      mkset(&ws,comma,rbrack,-1);
      orset(&ws,&fsys);
      expression(ws)  ;                 /* ̗vf̏             */
      if(gattr.typtr)
       if(compatible(gattr.typtr,lattr.typtr))/* O̗vfƂ̌^`FbN*/
        loadelement(fsp,varpart,0) ;    /* load&mms             */
       else pcerr(137,"") ;             /* W̗vf̌^sv     */
     }
     else {                             /* ŏ̗vf萔̎       */
      insymbol() ;                      /* ̗vfǂ             */
      mkset(&ws,comma,rbrack,-1);
      orset(&ws,&fsys);
      expression(ws)  ;                 /* ̗vf̏             */
      if(gattr.typtr)
       if(compatible(gattr.typtr,lattr.typtr)) {/* O̗vfƂ̌^`FbN*/
        if(gattr.kind == cst) {         /* l萔               */
         if(lattr.cval.ival <= gattr.cval.ival)   /*l̕傫*/
          if((lattr.cval.ival >= (long)fsp->sf.pw.elmin) &&/* vf͈̔*/
             (gattr.cval.ival <= (long)fsp->sf.pw.elmax)){ /*   `FbN*/
           for(m=(short)lattr.cval.ival;m<=(short)gattr.cval.ival;m++)
            *csetpart |=(1L << m);      /* W̒萔vf     */
           *cstpart = true ;
          }
          else
           pcerr(607,inttoch((long)fsp->sf.pw.elmax)) ;/* ͈͓ɂȂ*/
        }
        else {                          /* 萔..                   */
         load() ;                       /* load               */
         convertint(gattr.typtr) ;      /* KvȂordߐ        */
         gattr = lattr    ;
         loadelement(fsp,varpart,2) ;   /* 萔load&mms           */
        }
       }
       else pcerr(137,"") ;             /* W̗vf̌^sv     */
     }
}

/**************************************/
/*     factnil() : nil ̏         */
/**************************************/
static void factnil(void)
{
     gattr.typtr      = nilptr ;        /* nil ^                     */
     gattr.kind       = cst    ;
     gattr.cval.ival  = 0      ;
     insymbol()                ;
}

/**************************************/
/*    term() : ̍(term)̏     */
/**************************************/
static void term(Set fsys)
{
  attr lattr ;                          /* 1O̍̑            */
  enum operator lop ;                   /* 1ỎZq              */
  Set ws ;

     ws = fsys ;
     addset(ws,mulop) ;
     factor(ws) ;                       /* q̏                 */

     while(sy == mulop) {               /* * / div mod and ̎       */
      load() ;                          /* ̍load               */
      lattr = gattr ;                   /* ̍̑ޔ         */
      lop   = op    ;                   /* ̉Zqޔ           */
      insymbol() ;
      factor(ws) ;                      /* ̍̏               */
      load() ;                          /* ̍load               */
      if((lattr.typtr) && (gattr.typtr))
       switch(lop) {                    /* ZqŐU蕪         */
        case mul  : mulope(lattr) ;     /*  * Zq              */
                    break         ;
        case rdiv : rdivope(lattr) ;    /*  / Zq              */
                    break          ;
        case idiv  :                    /*  div Zq                */
        case imod  :                    /*  mod Zq                */
          if((lattr.typtr == intptr) &&
             (gattr.typtr == intptr))   /*  div/mod ̑Ώۂinteger   */
           (lop==idiv) ? gen0(iDVI) : gen0(iMOD);/*dvi / mod߂𐶐*/
          else {
           pcerr(134,"") ;              /* ZΏۂ̌^Ɍ         */
           gattr.typtr = nil ;
          }
          break ;
        case andop :                    /*  and Zq                */
          if((lattr.typtr == boolptr) &&
             (gattr.typtr == boolptr))  /*  and ̑Ώۂboolean       */
           gen0(iAND) ;                 /*   and߂𐶐            */
          else {
           pcerr(135,"and") ;           /* _^łȂ               */
           gattr.typtr = nil ;
          }
       }
      else gattr.typtr = nil ;
     }
}

/**************************************/
/*      mulope() : *  Zq      */
/**************************************/
static void mulope(attr fattr)
{
     if((fattr.typtr == intptr) &&      /*  * ̗[integer         */
        (gattr.typtr == intptr))
      gen0(iMPI) ;                      /* mpi߂̐              */
     else {
      cnvfloat(&fattr) ;                /* realւ̕ϊ           */
      if((fattr.typtr == realptr) &&
         (gattr.typtr == realptr))      /* [ƂrealɂȂĂ */
       gen0(iMPR) ;                     /*  mpr߂𐶐             */
      else if((gattr.typtr->form == power)        /* W^         */
        && compatible(fattr.typtr,gattr.typtr)) { /* ^K     */
        if(fattr.typtr->sf.pw.packed != both) /* O̎̋l߂/Ȃ*/
         gattr.typtr->sf.pw.packed = fattr.typtr->sf.pw.packed   ;
       gen0(iINT) ;                     /* int߂𐶐              */
      }
      else {                            /* ^KȂ             */
       pcerr(134,"") ;                  /* ZΏۂ̌^Ɍ         */
       gattr.typtr = nil;
      }
     }
}

/**************************************/
/*      rdivope() : /  Zq     */
/**************************************/
static void rdivope(attr fattr)
{
     cnvfloat(&fattr) ;                 /* realւ̕ϊ           */
     if((fattr.typtr == realptr) &&
        (gattr.typtr == realptr))       /* [ƂrealɂȂĂ */
      gen0(iDVR) ;                      /*  dvr߂𐶐             */
      else {
       pcerr(134,"") ;                  /* ZΏۂ̌^Ɍ         */
       gattr.typtr = nil ;
      }
}


/*********************************************/
/*     simpleexpression() : P̏     */
/*********************************************/
static void simpleexpression(Set fsys)
{
  boolean sign = false ;
  boolean neg ;
  attr lattr ;
  enum operator lop ;
  Set ws ;

     sign = (op==plus) || (op==minus) ; /* +  - ̎ ^             */
     if(sign) {
      neg = (op == minus)    ;          /* - ̎ true                */
      insymbol() ;
     }

     ws = fsys ;
     addset(ws,addop) ;
     term(ws) ;                         /* ̏                   */

     if(sign) {                         /* + -  Ă        */
       if(gattr.typtr==intptr) {
        if(neg)
         if(gattr.kind==cst)            /* 萔̎ l𔽓]    */
          gattr.cval.ival = -gattr.cval.ival ;
         else {                          /* ϐ̎                   */
          load() ;
          gen0(iNGI)  ;                  /* ngi ߂̏o             */
         }
       }
       else if(gattr.typtr==realptr) {  /* ͒萔łngr      */
        if(neg) {
         load() ;
         gen0(iNGR) ;                   /* ngr ߂̏o             */
        }
       }
       else {                           /* ȊOɕĂ*/
        pcerr(134,"") ;                 /* ZΏۂ̌^Ɍ         */
        gattr.typtr = nil ;             /* ̂߂nilƂ      */
       }
     }

     while(sy ==addop) {
      load()        ;
      lattr = gattr ;                   /* ̑ޔ             */
      lop   = op    ;                   /* ̉Zqޔ           */
      insymbol()    ;
      term(ws)      ;                   /* ̏                   */

      if((lattr.typtr) && (gattr.typtr))
       switch(lop) {                    /* ỎZqŐU蕪    */
        case plus  :
        case minus : plusminusope(lattr,lop);
                     break           ;  /* + -  ̉Zq          */
        case orop  : load()          ;
                     orope(lattr)    ;  /* or     Zq          */
                     break           ;
       }
      else gattr.typtr = nil    ;
     }
}

/**************************************/
/* plusminusope() : + -  Zq   */
/**************************************/
static void plusminusope(attr fattr,enum operator fop)
{
     if((fattr.typtr == intptr) &&      /* Oƍ̎Ƃinteger*/
        (gattr.typtr == intptr))        /*   ł                 */
      if((gattr.kind == cst) &&
         (gattr.cval.ival <= 32767)) {
        (fop == plus)
          ? gen1t(iINC,intptr,(int)gattr.cval.ival)
          : gen1t(iDEC,intptr,(int)gattr.cval.ival) ;
         gattr.kind = expr ;
      }
      else {
       load() ;
       (fop == plus) ? gen0(iADI) : gen0(iSBI) ; /* adi/sbi߂𐶐 */
      }
     else {
      load() ;
      cnvfloat(&fattr) ;                /* realɕϊ                 */
      if((fattr.typtr == realptr) &&    /* Oƍ̎Ƃreal   */
         (gattr.typtr == realptr))      /*   ɂȂĂ           */
       (fop == plus) ? gen0(iADR) : gen0(iSBR) ; /* adr/sbr߂𐶐 */
      else if((fattr.typtr->form == power)       /* O̎W^  */
         && compatible(fattr.typtr,gattr.typtr)){/* ̌^    */
       if(fattr.typtr->sf.pw.packed != both)  /* O̎̋l߂/Ȃ*/
        gattr.typtr->sf.pw.packed = fattr.typtr->sf.pw.packed   ;
       load() ;
       (fop == plus) ? gen0(iUNI) : gen0(iDIF) ; /* uni/dif߂𐶐 */
      }
      else {                            /* ^KȂ             */
       pcerr(134,"") ;                  /* ZΏۂ̌^Ɍ         */
       gattr.typtr = nil;
      }
     }
}

/**************************************/
/*      orope() : or Zq       */
/**************************************/
static void orope(attr fattr)
{
      if((fattr.typtr == boolptr) &&    /* Oƍ̎Ƃboolean*/
         (gattr.typtr == boolptr))      /*   ł                 */
       gen0(iIOR) ;                     /*   ior߂𐶐            */
      else {
       pcerr(135,"or") ;              /*  ZΏۂ͘_^łȂƑʖ*/
       gattr.typtr = nil ;
      }
}
